Debian Bug report logs - #514916
support multiple NICs

Package: live-boot; Maintainer for live-boot is Live Systems Maintainers <debian-live@lists.debian.org>; Source for live-boot is src:live-boot.

Reported by: rpowell <rpowell@looksmart.net>

Date: Wed, 11 Feb 2009 21:15:04 UTC

Severity: wishlist

Done: Daniel Baumann <daniel.baumann@progress-technologies.net>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#514916; Package live-initramfs. (Wed, 11 Feb 2009 21:15:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to rpowell <rpowell@looksmart.net>:
New Bug report received and forwarded. Copy sent to Debian Live <debian-live@lists.debian.org>. (Wed, 11 Feb 2009 21:15:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: rpowell <rpowell@looksmart.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: live-initramfs: scripts/live doesn't deal properly with multiple NICs
Date: Wed, 11 Feb 2009 13:10:25 -0800
Package: live-initramfs
Version: 1.154.8-1
Severity: important


I'm using line-initramfs as part of FAI to netboot machines with two
NICs, only one of which is actually set up to be DHCPd.  We have
hundreds of machines like this at my work, it's not something we can
reasonably change at the per-machine level.

The following patch makes everything work in my environment, and I
believe will still work in single-NIC setups:

*** /srv/fai/nfsroot/live/filesystem.dir/usr/share/initramfs-tools/scripts/functions    Wed Jan  7 06:14:37 2009
--- /srv/fai/broken/initramfs-tools_scripts_functions   Wed Feb 11 12:56:23 2009
***************
*** 269,278 ****
--- 269,294 ----
                ;;
        ""|on|any)
                # Bring up device
+               if [ -n "${DEVICE}" ]
+               then
                        ipconfig -t 180 ${DEVICE}
+               else
+                       # In some cases, the first run doesn't work but the second does immediately.
+                       ipconfig -t 60 all
+                       ipconfig -t 60 all
+                       ipconfig -t 60 all
+               fi
                ;;
        dhcp|bootp|rarp|both)
+               if [ -n "${DEVICE}" ]
+               then
                        ipconfig -t 180 -c ${IPOPTS} -d ${DEVICE}
+               else
+                       # In some cases, the first run doesn't work but the second does immediately.
+                       ipconfig -t 60 -c ${IPOPTS} -d all
+                       ipconfig -t 60 -c ${IPOPTS} -d all
+                       ipconfig -t 60 -c ${IPOPTS} -d all
+               fi
                ;;
        *)
                ipconfig -t 180 -d $IPOPTS
*** /srv/fai/nfsroot/live/filesystem.dir/usr/share/initramfs-tools/scripts/live Sun Feb  8 06:09:09 2009
--- /srv/fai/broken/initramfs-tools_scripts_live        Wed Feb 11 12:56:22 2009
***************
*** 699,709 ****
                udevsettle
        fi

!       ipconfig ${DEVICE} | tee /netboot.config

-       # source relevant ipconfig output
-       OLDHOSTNAME=${HOSTNAME}
-       . /tmp/net-${DEVICE}.conf
        [ -z ${HOSTNAME} ] && HOSTNAME=${OLDHOSTNAME}
        export HOSTNAME

--- 699,711 ----
                udevsettle
        fi

!       # We don't necessarily know which NIC we should be using
!       DEVICE=''
!
!       # make /scripts/live use configure_networking just like /scripts/nfs
!       # does; this sources /tmp/net-*.conf as well
!       configure_networking

        [ -z ${HOSTNAME} ] && HOSTNAME=${OLDHOSTNAME}
        export HOSTNAME



-- Package-specific info:

-- System Information:
Debian Release: 5.0
  APT prefers testing
  APT policy: (500, 'testing')
Architecture: i386 (i686)

Kernel: Linux 2.6.24.2-ls3 (SMP w/1 CPU core)
Locale: LANG=en_US, LC_CTYPE=en_US (charmap=ISO-8859-1)
Shell: /bin/sh linked to /bin/bash

Versions of packages live-initramfs depends on:
ii  busybox                       1:1.10.2-2 Tiny utilities for small and embed
ii  file                          4.26-1     Determines file type using "magic"
ii  initramfs-tools               0.92o      tools for generating an initramfs
ii  sudo                          1.6.9p17-1 Provide limited super user privile
ii  udev                          0.125-7    /dev/ and hotplug management daemo
ii  user-setup                    1.23       Set up initial user and password

Versions of packages live-initramfs recommends:
ii  eject                       2.1.5+deb1-4 ejects CDs and operates CD-Changer
ii  uuid-runtime                1.41.3-1     universally unique id library
ii  wget                        1.11.4-2     retrieves files from the web

Versions of packages live-initramfs suggests:
pn  curlftpfs                     <none>     (no description available)
pn  genext2fs                     <none>     (no description available)
pn  httpfs2                       <none>     (no description available)
ii  loop-aes-utils                2.13.1-4   Tools for mounting and manipulatin
pn  mtd-tools                     <none>     (no description available)
pn  squashfs-tools                <none>     (no description available)

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#514916; Package live-initramfs. (Wed, 11 Feb 2009 21:39:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Wed, 11 Feb 2009 21:39:02 GMT) Full text and rfc822 format available.

Message #10 received at 514916@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 514916@bugs.debian.org, 514916-submitter@bugs.debian.org
Subject: Re: live-initramfs: scripts/live doesn't deal properly with multiple NICs
Date: Wed, 11 Feb 2009 22:36:09 +0100
severity 514916 normal
thanks

Hi,

for lenny, this is to late to be fixed and properly tested. However,
I'll make sure that we'll try to fix it soon after lenny and, if
positive, that it will make it into lenny r1.

Regards,
Daniel

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Severity set to `normal' from `important' Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Wed, 11 Feb 2009 21:39:03 GMT) Full text and rfc822 format available.

Message sent on to rpowell <rpowell@looksmart.net>:
Bug#514916. (Wed, 11 Feb 2009 21:39:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#514916; Package live-initramfs. (Wed, 11 Feb 2009 21:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to rpowell <rpowell@looksmart.net>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Wed, 11 Feb 2009 21:57:03 GMT) Full text and rfc822 format available.

Message #20 received at 514916@bugs.debian.org (full text, mbox):

From: rpowell <rpowell@looksmart.net>
To: daniel@debian.org, 514916-quiet@bugs.debian.org
Cc: 514916@bugs.debian.org, 514916-submitter@bugs.debian.org
Subject: Re: Bug#514916: live-initramfs: scripts/live doesn't deal properly with multiple NICs
Date: Wed, 11 Feb 2009 13:54:42 -0800
On Wed, Feb 11, 2009 at 10:36:09PM +0100, Daniel Baumann wrote:
> severity 514916 normal
> thanks
> 
> Hi,
> 
> for lenny, this is to late to be fixed and properly tested. However,
> I'll make sure that we'll try to fix it soon after lenny and, if
> positive, that it will make it into lenny r1.

Great stuff.  Thank you!

For the record, the current behaviour is that ipconfig hangs
forever if the non-DHCP device happens to be eth0.  Eww.

-Robin




Information stored :
Bug#514916; Package live-initramfs. (Wed, 11 Feb 2009 21:57:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to rpowell <rpowell@looksmart.net>:
Extra info received and filed, but not forwarded. (Wed, 11 Feb 2009 21:57:04 GMT) Full text and rfc822 format available.

Message sent on to rpowell <rpowell@looksmart.net>:
Bug#514916. (Wed, 11 Feb 2009 21:57:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#514916; Package live-initramfs. (Thu, 12 Feb 2009 08:42:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Marco Amadori <amadorim@vdavda.com>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Thu, 12 Feb 2009 08:42:02 GMT) Full text and rfc822 format available.

Message #33 received at 514916@bugs.debian.org (full text, mbox):

From: Marco Amadori <amadorim@vdavda.com>
To: rpowell <rpowell@looksmart.net>, 514916@bugs.debian.org
Subject: It seems to be related to another package
Date: Thu, 12 Feb 2009 09:40:03 +0100
On Wednesday 11 February 2009, 22:10:25, rpowell wrote:

> Package: live-initramfs

> The following patch makes everything work in my environment, and I
> believe will still work in single-NIC setups:

> ***
> /srv/fai/nfsroot/live/filesystem.dir/usr/share/initramfs-tools/scripts/func
>tions    Wed Jan  7 06:14:37 2009 ---
> /srv/fai/broken/initramfs-tools_scripts_functions   Wed Feb 11 12:56:23

Thanks for the patch but it applies to a file which belongs 
to "initramfs-tools", not "live-initramfs" which is an extension (or an hook) 	
of the former.

-- 
ESC:wq

-- 
This message has been scanned for viruses and
dangerous content by MailScanner, and is
believed to be clean.





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#514916; Package live-initramfs. (Thu, 12 Feb 2009 19:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to rpowell <rpowell@looksmart.net>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Thu, 12 Feb 2009 19:30:03 GMT) Full text and rfc822 format available.

Message #38 received at 514916@bugs.debian.org (full text, mbox):

From: rpowell <rpowell@looksmart.net>
To: Marco Amadori <amadorim@vdavda.com>
Cc: 514916@bugs.debian.org
Subject: Not really (was Re: It seems to be related to another package)
Date: Thu, 12 Feb 2009 11:27:08 -0800
On Thu, Feb 12, 2009 at 09:40:03AM +0100, Marco Amadori wrote:
> On Wednesday 11 February 2009, 22:10:25, rpowell wrote:
> 
> > Package: live-initramfs
> 
> > The following patch makes everything work in my environment, and I
> > believe will still work in single-NIC setups:
> 
> > ***
> > /srv/fai/nfsroot/live/filesystem.dir/usr/share/initramfs-tools/scripts/func
> >tions    Wed Jan  7 06:14:37 2009 ---
> > /srv/fai/broken/initramfs-tools_scripts_functions   Wed Feb 11 12:56:23
> 
> Thanks for the patch but it applies to a file which belongs to
> "initramfs-tools", not "live-initramfs" which is an extension (or
> an hook) of the former.

The real problem is with scripts/live, though, which *is* in
live-initramfs:

$ dpkg -S /usr/share/initramfs-tools/scripts/live
live-initramfs: /usr/share/initramfs-tools/scripts/live

I would like to think that two Debian packages could work to fix
something at the same time.  :)

However, the problem can be fixed solely in live-initramfs, like so:

--- /srv/fai/nfsroot/live/filesystem.dir/usr/share/initramfs-tools/scripts/live 2009-02-08 06:09:09.000000000 -0800
+++ /srv/fai/broken/initramfs-tools_scripts_live        2009-02-12 11:26:04.000000000 -0800
@@ -699,11 +699,17 @@
                udevsettle
        fi

-       ipconfig ${DEVICE} | tee /netboot.config
+       # We don't necessarily know which NIC we should be using
+       DEVICE=''
+
+       # make /scripts/live use configure_networking just like /scripts/nfs
+       # does; this sources /tmp/net-*.conf as well
+       ipconfig -t 60 all
+       ipconfig -t 60 all
+       ipconfig -t 60 all
+
+       . /tmp/net-*.conf

-       # source relevant ipconfig output
-       OLDHOSTNAME=${HOSTNAME}
-       . /tmp/net-${DEVICE}.conf
        [ -z ${HOSTNAME} ] && HOSTNAME=${OLDHOSTNAME}
        export HOSTNAME







Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#514916; Package live-initramfs. (Fri, 13 Feb 2009 07:36:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Marco Amadori <amadorim@vdavda.com>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Fri, 13 Feb 2009 07:36:10 GMT) Full text and rfc822 format available.

Message #43 received at 514916@bugs.debian.org (full text, mbox):

From: Marco Amadori <amadorim@vdavda.com>
To: rpowell <rpowell@looksmart.net>, 514916@bugs.debian.org
Subject: Re: Bug#514916: Not really (was Re: It seems to be related to another package)
Date: Fri, 13 Feb 2009 08:33:44 +0100
On Thursday 12 February 2009, 20:27:08, rpowell wrote:

> I would like to think that two Debian packages could work to fix
> something at the same time.  :)

Sure, mine was just a request to consider if it could be the case of moving 
the bug to another package to track it better.

> However, the problem can be fixed solely in live-initramfs, like so:

Thanks for the patch, I think it could be late for Lenny perhaps :-)

-- 
ESC:wq

-- 
This message has been scanned for viruses and
dangerous content by MailScanner, and is
believed to be clean.





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#514916; Package live-initramfs. (Thu, 19 Feb 2009 06:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Robin Lee Powell <rlpowell@digitalkingdom.org>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Thu, 19 Feb 2009 06:09:03 GMT) Full text and rfc822 format available.

Message #48 received at 514916@bugs.debian.org (full text, mbox):

From: Robin Lee Powell <rlpowell@digitalkingdom.org>
To: 514916@bugs.debian.org
Subject: Slightly better way.
Date: Wed, 18 Feb 2009 22:07:46 -0800
I'm now working on etch FAI, and ran into a totally different set of
bugs.

-_-

As a side effect, I've come up with a more general (in the sense of
working with the older stuff), faster way of dealing with the
multiple ethernet thing.  It stops when any one NIC is done.

--- live.orig   2009-02-19 06:03:28.000000000 +0000
+++ live        2009-02-19 06:07:01.000000000 +0000
@@ -635,11 +635,17 @@
        udevtrigger
        udevsettle

-       ipconfig ${DEVICE} | tee /netboot.config
+       while [ ! "$(ifconfig -a | grep -v 127.0.0.1 | grep 'inet addr:')" ]
+       do
+               for nic in $(ifconfig -a | grep '^[^ ]' | grep -v '^lo' | sed 's/ .*//' | tr '\012' ' ')
+               do
+                       ipconfig -t 5 $nic
+               done
+       done

        # source relevant ipconfig output
        OLDHOSTNAME=${HOSTNAME}
-       . /tmp/net-${DEVICE}.conf
+       . /tmp/net-*.conf
        [ -z ${HOSTNAME} ] && HOSTNAME=${OLDHOSTNAME}
        export HOSTNAME

-Robin

-- 
They say:  "The first AIs will be built by the military as weapons."
And I'm thinking:  "Does it even occur to you to try for something
other than the default outcome?" -- http://shorl.com/tydruhedufogre
http://www.digitalkingdom.org/~rlpowell/ *** http://www.lojban.org/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#514916; Package live-initramfs. (Thu, 19 Feb 2009 09:30:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Chris Lamb <lamby@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Thu, 19 Feb 2009 09:30:09 GMT) Full text and rfc822 format available.

Message #53 received at 514916@bugs.debian.org (full text, mbox):

From: Chris Lamb <lamby@debian.org>
To: Robin Lee Powell <rlpowell@digitalkingdom.org>, 514916@bugs.debian.org
Cc: 514916@bugs.debian.org
Subject: Re: Bug#514916: Slightly better way.
Date: Thu, 19 Feb 2009 09:19:02 +0000
[Message part 1 (text/plain, inline)]
Robin Lee Powell wrote:

> +       for nic in $(ifconfig -a | grep '^[^ ]' | grep -v '^lo' |
>                                        sed 's/ .*//' | tr '\012' ' ')

That's horrible. What's wrong with:

 for IF in /sys/class/net/*
 do
     # ...
 done


Regards,

-- 
      ,''`.
     : :'  :     Chris Lamb
     `. `'`      lamby@debian.org
       `-
[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#514916; Package live-initramfs. (Thu, 19 Feb 2009 09:36:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Robin Lee Powell <rlpowell@digitalkingdom.org>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Thu, 19 Feb 2009 09:36:10 GMT) Full text and rfc822 format available.

Message #58 received at 514916@bugs.debian.org (full text, mbox):

From: Robin Lee Powell <rlpowell@digitalkingdom.org>
To: Chris Lamb <lamby@debian.org>
Cc: 514916@bugs.debian.org
Subject: Re: Bug#514916: Slightly better way.
Date: Thu, 19 Feb 2009 01:33:07 -0800
On Thu, Feb 19, 2009 at 09:19:02AM +0000, Chris Lamb wrote:
> Robin Lee Powell wrote:
> 
> > +       for nic in $(ifconfig -a | grep '^[^ ]' | grep -v '^lo' |
> >                                        sed 's/ .*//' | tr '\012' ' ')
> 
> That's horrible. What's wrong with:
> 
>  for IF in /sys/class/net/*
>  do
>      # ...
>  done

I always forget about /sys; sorry.  You still need to drop lo,
though.

-Robin


-- 
They say:  "The first AIs will be built by the military as weapons."
And I'm thinking:  "Does it even occur to you to try for something
other than the default outcome?" -- http://shorl.com/tydruhedufogre
http://www.digitalkingdom.org/~rlpowell/ *** http://www.lojban.org/




Severity set to 'wishlist' from 'normal' Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Mon, 14 Dec 2009 10:27:11 GMT) Full text and rfc822 format available.

Changed Bug title to 'support multiple NICs' from 'live-initramfs: scripts/live doesn't deal properly with multiple NICs' Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Mon, 01 Feb 2010 09:54:06 GMT) Full text and rfc822 format available.

Bug reassigned from package 'live-initramfs' to 'live-boot'. Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Fri, 16 Jul 2010 03:09:05 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions live-initramfs/1.154.8-1. Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Fri, 16 Jul 2010 03:09:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Live Systems Maintainers <debian-live@lists.debian.org>:
Bug#514916; Package live-boot. (Wed, 19 Jun 2013 06:00:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel.baumann@progress-technologies.net:
Extra info received and forwarded to list. Copy sent to Live Systems Maintainers <debian-live@lists.debian.org>. (Wed, 19 Jun 2013 06:00:10 GMT) Full text and rfc822 format available.

Message #71 received at 514916@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel.baumann@progress-technologies.net>
To: 536796@bugs.debian.org, 563082@bugs.debian.org, 563735@bugs.debian.org, 568502@bugs.debian.org, 598542@bugs.debian.org, 514916@bugs.debian.org, 442333@bugs.debian.org, 452444@bugs.debian.org
Subject: live-boot
Date: Wed, 19 Jun 2013 07:58:26 +0200
close 442333
close 452444
close 514916
close 536796
close 563082
close 563735
close 568502
close 598542
thanks

Eventually, live-boot will support additional stuff (it's on our todo
page at http://live.debian.net/devel/live-boot/todo), but since these
are wishlist items open for long time, requireing quite a bit of work to
implement and nobody worked on them for years, I do not see much point
in keeping it rotting in the bts, that's what we have the todo page for
(that includes above things, and much more).

-- 
Address:        Daniel Baumann, Donnerbuehlweg 3, CH-3012 Bern
Email:          daniel.baumann@progress-technologies.net
Internet:       http://people.progress-technologies.net/~daniel.baumann/



Marked Bug as done Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Wed, 19 Jun 2013 06:00:32 GMT) Full text and rfc822 format available.

Notification sent to rpowell <rpowell@looksmart.net>:
Bug acknowledged by developer. (Wed, 19 Jun 2013 06:00:33 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 17 Jul 2013 07:28:02 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 19:16:57 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.